package wmo

import (
	"context"
	"go.mongodb.org/mongo-driver/bson"
	"go.mongodb.org/mongo-driver/mongo"
)

func (c *Coll[TData]) DeleteOneByID(ctx context.Context, id EntityID) error {
	_, err := c.coll.DeleteOne(ctx, bson.M{"_id": id})
	if err != nil {
		return err
	}

	return nil
}

func (c *Coll[TData]) DeleteOne(ctx context.Context, filterQuery bson.M) error {
	_, err := c.coll.DeleteOne(ctx, filterQuery)
	if err != nil {
		return err
	}

	return nil
}

func (c *Coll[TData]) DeleteMany(ctx context.Context, filterQuery bson.M) (*mongo.DeleteResult, error) {
	res, err := c.coll.DeleteMany(ctx, filterQuery)
	if err != nil {
		return nil, err
	}

	return res, nil
}
